// C Source File
// Created 11.05.2005; 9:18:05 AM


 //   TI-Tetravex: Tetravex clone
 //   Written by James Trimble <jimmit_t@yahoo.com>
 // 	Copyright 2005 James Trimble
 //
 //   This program is free software; you can redistribute it and/or modify
 //   it under the terms of the GNU General Public License as published by
 //   the Free Software Foundation; either version 2 of the License, or
 //   (at your option) any later version.
 //
 //   This program is distributed in the hope that it will be useful,
 //   but WITHOUT ANY WARRANTY; without even the implied warranty of
 //   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 //   GNU General Public License for more details.
 //
 //   You should have received a copy of the GNU General Public License
 //   along with this program; if not, write to the Free Software
 //   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 // If you decide to use some of this code in your own program please send me an email.
 // I'd love to know that something I wrote was helpful.

 // TODO: Nothing right now, if you find anything, please email me.
 //
 //

// Includes
#include <tigcclib.h>

// Delete or comment out the items you do not need.
#define COMMENT_STRING         "TI-Tetravex"
#define COMMENT_PROGRAM_NAME   "TI-Tetravex"
#define COMMENT_VERSION_STRING "Version 2.0b"
#define COMMENT_VERSION_NUMBER 2,0,0,0 /* major, minor, revision, subrevision */
/*#define COMMENT_BW_ICON \
	{0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000}
#define COMMENT_GRAY_ICON \
	{0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000}, \
	{0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000, \
	 0b0000000000000000}
*/

// User defines
#define WITHLINES 0
#define T_OFFX 6
#define T_OFFY 1+(1-WITHLINES)
#define R_OFFX 12
#define R_OFFY 6
#define B_OFFX 6
#define B_OFFY 11-(1-WITHLINES)
#define L_OFFX 0
#define L_OFFY 6
#define SIDE 18
#define R_BOARDX 86
#define R_BOARDY 0
#define L_BOARDX 0
#define L_BOARDY 0
#define SIZE 4
#define SCORECOUNT 5


// Types
typedef struct piece_t {
	int t;
	int r;
	int l;
	int b;
} piece;

typedef struct score_t {
	char name[21];
	int min;
	int sec;
} score;

enum
{
	gameover,
	paused,
	playingup,
	playingdown,
};

enum
{
	l_board,
	r_board,
};

// Globals
	int _ti89;
	int game_state = gameover;
	piece pieces[SIZE][SIZE];
	piece gameboard[SIZE][SIZE];
	INT_HANDLER oldint5 = NULL;	
	volatile int seconds=0;
	volatile int minutes=0;	
	volatile int resettime  = 1;
	volatile int running = 0;
	volatile int mseconds50 = 0; // counts in 50ms steps (not exact 50ms, but 1000/19 ms)

//PrintDebug - Takes in a string and prints it at the bottom of the window
void PrintDebug(char * msg)
{
	ScrRectFill(&(SCR_RECT){{0,80,160,90}},&(SCR_RECT){{0,80,160,90}},A_REVERSE);
	DrawStr(0,80,msg,A_NORMAL);
}

// Handles timing
DEFINE_INT_HANDLER (TimerISR)
{
  char msg[10];
  if (resettime) {
        mseconds50=seconds=minutes=resettime=0;
    }
	else if(running)
	{
		mseconds50++;
		if (mseconds50 == 19)
		{
			mseconds50 = 0;
			seconds++;
	  	if (seconds >= 60)
			{
		  	minutes++;
		  	seconds -= 60;
		  }
		  sprintf(msg,"%3d:%02d",minutes,seconds);
		  PrintDebug(msg);
		}
	}
	ExecuteHandler(oldint5);
}

// Comparison Function
CALLBACK short score_comp(const void *a, const void *b)
{
  score score1;
  score score2;
  
  strcpy(score1.name,(*(const score*)a).name);
  score1.min = (*(const score*)a).min;
  score1.sec = (*(const score*)a).sec;

  strcpy(score2.name,(*(const score*)b).name);
  score2.min = (*(const score*)b).min;
  score2.sec = (*(const score*)b).sec;

  if (score1.min < score2.min)
  	return -1;
  else if (score1.min == score2.min)
  {
  	if (score1.sec < score2.sec)
  		return -1;
  	else if (score1.sec == score2.sec)
  	{
  		return strcmp(score1.name, score2.name);
  	}
  	else
  		return 1;
  }
  else
  	return 1;
}


// Draw Block - Draws a tetravex piece without numbers
void DrawBlock(int x, int y)
{
	
	// Diagonal Lines
	if (WITHLINES)
	{
		DrawLine(x,y,SIDE+x,SIDE+y,A_NORMAL);
		DrawLine(x,SIDE+y,SIDE+x,y,A_NORMAL);
	}
	
	// Sides
	DrawLine(x,y,SIDE+x,y,A_NORMAL);
	DrawLine(x,y,x,SIDE+y,A_NORMAL);
	DrawLine(SIDE+x,SIDE+y,SIDE+x,y,A_NORMAL);
	DrawLine(SIDE+x,SIDE+y,x,SIDE+y,A_NORMAL);
}

// Draw Values - Draws the numbers in the correct place for a piece at x,y
// Note: uses the SIDE, ?_OFFX, and ?_OFFY defines
void DrawValues(int x, int y, piece myPiece)
{
	char msg[2];

	sprintf(msg,"%d",myPiece.t);
	DrawStr((x+T_OFFX)*SIDE/18,(y+T_OFFY)*SIDE/18,msg,A_NORMAL);	

	sprintf(msg,"%d",myPiece.r);
	DrawStr((x+R_OFFX)*SIDE/18,(y+R_OFFY)*SIDE/18,msg,A_NORMAL);	

	sprintf(msg,"%d",myPiece.b);	
	DrawStr((x+B_OFFX)*SIDE/18,(y+B_OFFY)*SIDE/18,msg,A_NORMAL);	

	sprintf(msg,"%d",myPiece.l);	
	DrawStr((x+L_OFFX)*SIDE/18,(y+L_OFFY)*SIDE/18,msg,A_NORMAL);	
}

// DrawPiece - Draws the piece with the values in place
void DrawPiece(int row, int col, int board, piece myPiece)
{
	if (board == r_board)
	{
		DrawBlock(SIDE*col+R_BOARDX,SIDE*row+R_BOARDY);
		DrawValues(SIDE*col+R_BOARDX,SIDE*row+R_BOARDY,myPiece);
	}
	else if (board == l_board)
	{
		DrawBlock(SIDE*col+L_BOARDX,SIDE*row+L_BOARDY);
		DrawValues(SIDE*col+L_BOARDX,SIDE*row+L_BOARDY,myPiece);
	}
}

// Initialize_Pieces - void resets the gameboard and the pieces
void Initialize_Pieces (void)
{
	int i,j;
	randomize();
	for (i=0;i<4;i++)
	{
		for(j=0;j<4;j++)
		{
			if (i == 0)
				pieces[i][j].t = random(10);
			else
				pieces[i][j].t = pieces[i-1][j].b;
			
			if (j == 0)
				pieces[i][j].l = random(10);
			else
				pieces[i][j].l = pieces[i][j-1].r;
			
		  pieces[i][j].b = random(10);
			pieces[i][j].r = random(10);
												
			gameboard[i][j].t = -1;
			gameboard[i][j].r = -1;
			gameboard[i][j].b = -1;
			gameboard[i][j].l = -1;
		}
	}
}

// ToggleCursor - XORS the piece on the specified board and at the specified location
void ToggleCursor(int row, int col, int board)
{
	if (board == r_board)
		FillLines2(&(WIN_RECT){SIDE*col+R_BOARDX,SIDE*row+R_BOARDY+SIDE, SIDE*col+R_BOARDX+SIDE,SIDE*row+R_BOARDY+SIDE},
		&(WIN_RECT){SIDE*col+R_BOARDX,SIDE*row+R_BOARDY, SIDE*col+R_BOARDX+SIDE,SIDE*row+R_BOARDY},
		&(SCR_RECT){{0, 0, 160, 80}},A_XOR);
	else
		FillLines2(&(WIN_RECT){SIDE*col+L_BOARDX,SIDE*row+L_BOARDY+SIDE, SIDE*col+L_BOARDX+SIDE,SIDE*row+L_BOARDY+SIDE},
		&(WIN_RECT){SIDE*col+L_BOARDX,SIDE*row+L_BOARDY, SIDE*col+L_BOARDX+SIDE,SIDE*row+L_BOARDY},
		&(SCR_RECT){{0, 0, 160, 80}},A_XOR);
}

// ErasePiece - Draws a blank square
void ErasePiece(int x, int y, int board)
{
	if (board == l_board)
		ScrRectFill(&(SCR_RECT){{SIDE*y+L_BOARDX,SIDE*x+L_BOARDY,SIDE*y+L_BOARDX+SIDE,SIDE*x+L_BOARDY+SIDE}},&(SCR_RECT){{0,0,160,80}},A_REVERSE);
	else
		ScrRectFill(&(SCR_RECT){{SIDE*y+R_BOARDX,SIDE*x+R_BOARDY,SIDE*y+R_BOARDX+SIDE,SIDE*x+R_BOARDY+SIDE}},&(SCR_RECT){{0,0,160,80}},A_REVERSE);
}

// ValidMove - Return 1 if the move is allowable
int ValidMove (int row, int col, piece myPiece)
{
	if (row < 0 || row >= SIZE || col < 0 || col >= SIZE)
		return 0;
	
	if (col != 0 && gameboard[row][col-1].r != -1 && gameboard[row][col-1].r != myPiece.l)
	{
		//PrintDebug("Not Valid on Left");
		return 0;
	}
	if (col != SIZE-1 && gameboard[row][col+1].l != -1 && gameboard[row][col+1].l != myPiece.r)
	{
			//PrintDebug("Not Valid on Right");
			return 0;
	}
	if (row != 0 && gameboard[row-1][col].b!=-1 && gameboard[row-1][col].b != myPiece.t)
	{
		//PrintDebug("Not Valid on Top");
		return 0;
	}
	if (row != SIZE-1 && gameboard[row+1][col].t != -1 && gameboard[row+1][col].t != myPiece.b)
	{
			//PrintDebug("Not Valid on Bottom");
			return 0;
	}
	
	return 1;
}

//RotateCol - Vertically rotates a column up
void RotateCol(int col)
{
	piece tempPiece = pieces[0][col];
	pieces[0][col] = pieces[1][col];
	pieces[1][col] = pieces[2][col];
	pieces[2][col] = pieces[3][col];
	pieces[3][col] = tempPiece;
}

//RotateRow - Horizontally rotates a row left
void RotateRow(int row)
{
	piece tempPiece = pieces[row][0];
	pieces[row][0] = pieces[row][1];
	pieces[row][1] = pieces[row][2];
	pieces[row][2] = pieces[row][3];
	pieces[row][3] = tempPiece;
}

//RandPieces - Randomize the choices
void RandPieces()
{
	int i,k;
	for (k=0;k<50;k++)
	{
		i=random(4);
		if (k % 2 == 0)
			RotateCol(i);
		else
			RotateRow(i);
	}
}

// CheckWin - Returns 1 if the puzzle has been solved
int CheckWin()
{
	int i,j;
	for (i=0; i<SIZE;i++)
	{
		for(j=0;j<SIZE;j++)
		{
			if (gameboard[i][j].t == -1)
				return 0;
		}
	}
	return 1;
}

// Intro - Displays intro screen
void Intro()
{
	ClrScr();
	DrawStr(30,40,"TI-Tetravex V2.0b",A_NORMAL);
	DrawStr(30,50,"by James Trimble",A_NORMAL);
	DrawStr(25,60,"jimmit_t@yahoo.com",A_NORMAL);
	//DrawStr(16,80,"Pour la fille qui me",A_NORMAL);
	//DrawStr(33,90,"fait le sourire",A_NORMAL);
	while(!kbhit());
	ngetchx();
}

// GetScores - Reads in high scores
void GetScores(score* highScores)
{
	
	char c[21];
	char ch;
	int i;
	int numscores = 0;
	
	for (i=0; i < SCORECOUNT; i++)
	{
		strcpy(highScores[i].name,"Nobody");
		highScores[i].min = 2006;
		highScores[i].sec = 06;
	}
	
  FILE *f = fopen("tetradat", "r");
  if (f != NULL)
  {
	  ch = fgetc(f);
		fgets(c, 21, f);
	  
		for (i=0; i < SCORECOUNT && (fscanf(f, "%s", highScores[i].name)) != EOF; i++)
		{
			  fscanf(f, "%d", &highScores[i].min);
			  fscanf(f, "%d", &highScores[i].sec);
		}
		fclose(f);
	}

}

// UpdateScores - Updates high scores
void UpdateScores(score newScore, score* highScores)
{
	FILE *fp;
	int j;
	highScores[SCORECOUNT] = newScore;
	qsort(highScores, SCORECOUNT+1, sizeof(score), score_comp);
	
	if ((fp = fopen ("tetradat", "w")) != NULL)
	{
		fputc (0, fp);
		fputs ("HSC", fp);
		fprintf(fp, "\n");
		clrscr();
		for (j=0;j < SCORECOUNT;j++)
		{
			fprintf(fp, "%s %d %d \n", highScores[j].name, highScores[j].min, highScores[j].sec);
		}
		fputc (0, fp);
		fputc (OTH_TAG, fp);
		fclose (fp);
	}
}

// PrintScores - Prints the scores to the screen, the scores must first be read by GetScores
void PrintScores(score* highScores)
{
	int j;
	clrscr();
	printf("High Scores: \n");
	for (j=0;j<SCORECOUNT;j++)
	{
		printf("%d. %-10s - %d:%02d\n", j+1, highScores[j].name, highScores[j].min, highScores[j].sec);
	}
}

// Main Function
void _main(void)
{
	//short clockrate;
	int i,j;
	int row=0,col=0;
	int board=l_board;
	int gamestate = playingdown;
	short key;
	piece upPiece;
	char debugmsg[100];
	FILE *f;
	score highscores[SCORECOUNT+1];
	score myScore;
	int numscores = 0;
	HANDLE handle = DialogNewSimple (140, 55);

	Initialize_Pieces();
	Intro();
	ClrScr();
	
	// Draw the playing board
	for (i=0; i < 4; i++)
	{
		for (j=0;j<4;j++)
		{
			DrawBlock(SIDE*i,SIDE*j);
		}
	}

	RandPieces();
	// Draw the pieces to choose from
	for (i=0;i<SIZE;i++)
	{
		for (j=0;j<SIZE;j++)
		{
			DrawPiece(i,j,r_board,pieces[i][j]);
		}
	}



	ToggleCursor(row,col,board);

	resettime=1;
	oldint5 = GetIntVec(AUTO_INT_5); // Setup the clock interrupt
	SetIntVec(AUTO_INT_5, TimerISR);
	running = 1; // Start the clock
	
	while (gamestate != gameover)
	{
  	if (kbhit())
  	{
 			// Start handling key presses
  		key=ngetchx();
  		if (key == KEY_UP && row > 0)
	  	{
	  	ToggleCursor(row,col,board);
  			row--;
  			ToggleCursor(row,col,board);
  		}
  		else if (key == KEY_DOWN && row < 3)
  		{
  		ToggleCursor(row,col,board);
  			row++;
  			ToggleCursor(row,col,board);
  		}
  		else if (key == KEY_RIGHT && (board == l_board || col < 3))
			{
					ToggleCursor(row,col,board);
				if (col == 3 && board == l_board)
				{
					col = 0;
					board = r_board;
				}
				else
					col++;
					ToggleCursor(row,col,board);
			}	
			else if (key == KEY_LEFT && (board != l_board || col > 0))
			{
				ToggleCursor(row,col,board);
				if (col == 0 && board == r_board)
				{
					col = 3;
					board = l_board;
				}
				else
					col--;
				ToggleCursor(row,col,board);
			}
			else if (key == KEY_F1)// || key == KEY_F2) // F2 is used for debugging, it makes you instantly win
				{
					// If we haven't picked anything up yet
					if (gamestate == playingdown)
					{
						// and it's on the left board
						if (board == l_board && gameboard[row][col].t != -1)
						{
							// pickup a piece from the gameboard
							upPiece = gameboard[row][col];
							ErasePiece(row,col,l_board);
							DrawBlock(SIDE*col+L_BOARDX,SIDE*row+L_BOARDY);
							gameboard[row][col].t=-1;		
							gameboard[row][col].r=-1;		
							gameboard[row][col].b=-1;		
							gameboard[row][col].l=-1;		
							ToggleCursor(row,col,l_board);				
							//ScrRectFill(&(SCR_RECT){{0,80,160,90}},&(SCR_RECT){{0,80,160,90}},A_REVERSE); // Debugging
							//DrawStr(0,80,"PICKED UP FROM LBOARD",A_NORMAL); // Debugging
							gamestate = playingup;
						}
						// and it's on the right board
						else if (board == r_board && pieces[row][col].t != - 1)
						{
							// pick up a piece from the pieces board
							upPiece = pieces[row][col];
							ErasePiece(row,col,r_board);
							DrawBlock(SIDE*col+R_BOARDX,SIDE*row+R_BOARDY);
							pieces[row][col].t=-1;	
							pieces[row][col].r=-1;	
							pieces[row][col].b=-1;	
							pieces[row][col].l=-1;	
							gamestate = playingup;
							ToggleCursor(row,col,r_board);
							//ScrRectFill(&(SCR_RECT){{0,80,160,90}},&(SCR_RECT){{0,80,160,90}},A_REVERSE); // Debugging
							//sprintf(debugmsg,"DBG:%d,%d",SIDE*col+R_BOARDX,SIDE*row+R_BOARDY); // Debugging
							//DrawStr(0,80,debugmsg,A_NORMAL); // Debugging
						}
												
					}
					// If something's in our hand
					else if (gamestate == playingup) // || key == KEY_F2) // F2 used for debugging
					{
						// and it's on the left board, not taken, and a valid move
						if (board == l_board && gameboard[row][col].t == -1 && ValidMove(row, col, upPiece))
						{
							// place a piece on the gameboard
							gameboard[row][col] = upPiece;
							ErasePiece(row,col,l_board);
							DrawPiece(row,col,l_board,upPiece);
							//sprintf(debugmsg,"DBG:DP(%d,%d,left,piece);",row,col);
							upPiece.t=-1;
							gamestate = playingdown;
							ToggleCursor(row,col,board);
							//PrintDebug(debugmsg);
						}
						// and it's on the right board and not taken
						else if (pieces[row][col].t == -1 && board == r_board)
						{
							// place a piece on the pieces board
							pieces[row][col] = upPiece;
							ErasePiece(row,col,r_board);
							DrawPiece(row,col,r_board,upPiece);
							upPiece.t=-1;	
							gamestate = playingdown;
							ToggleCursor(row,col,board);
							
						}
						
						if (CheckWin()) // || key == KEY_F2) // F2 for debugging
						{
							running = 0; // Stop the clock
							// Set the user's time
							myScore.min = minutes;
							myScore.sec = seconds;
							// Get the user's name
							DialogAddTitle (handle, "YOU WIN!", BT_OK, BT_CANCEL);
							DialogAddText (handle, 3, 20, "Enter name (max. 10 chars)");
  						DialogAddRequest (handle, 3, 30, "Your name", 0, 10, 14);
  						strcpy(debugmsg,'\0');
  						if (DialogDo (handle, CENTER, CENTER, debugmsg, NULL) == KEY_ENTER)
    						strcpy(myScore.name,debugmsg);
							HeapFree (handle);
							
							// Update the highscores list
							GetScores(highscores); // Populate the highscores list
							UpdateScores(myScore, highscores); // Add the new entry to the list
							
							gamestate = gameover; // End the game
						}	
					}

				}
			else if (key == KEY_ESC)
				gamestate = gameover; // Quit the game
				
  	}
}
	running = 0; // The beat just rocks me, don't try to stop me, throw it up and go... don't clock me! ;) Turns the clock off
	
	// Show the highscores list	
	GetScores(highscores);
	PrintScores(highscores);

	// Wait for a keypress before quitting
	while(!kbhit());
	key = ngetchx();
	
	
  SetIntVec(AUTO_INT_5, oldint5);
}
